Index: trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/general_mesh.py
===================================================================
--- trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/general_mesh.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/general_mesh.py	(revision 8690)
@@ -671,4 +671,10 @@
         return unique_verts.keys()
 
+        # Note Padarn 27/11/12:
+        # This function was modified, but then it was deicded it was not
+        # needed. It should be restored if it is used elsewhere in the code
+        # (it was being used in quantity.py in the _set_vertex_values function).
+        # Note however, the function in the head of the code is very slow and
+        # could be easily sped up many fold.
     def get_triangles_and_vertices_per_node(self, node=None):
         """Get triangles associated with given node.
Index: trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/quantity.py
===================================================================
--- trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/quantity.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/quantity.py	(revision 8690)
@@ -623,4 +623,5 @@
                                                      use_cache=use_cache)
         elif filename is not None:
+
             if hasattr(self.domain, 'points_file_block_line_size'):
                 max_read_lines = self.domain.points_file_block_line_size
@@ -940,4 +941,5 @@
         """
 
+
         msg = 'Filename must be a text string'
         assert isinstance(filename, basestring), msg
@@ -1297,5 +1299,14 @@
         #
         self._set_vertex_values(vertex_list, A)
-            
+
+    # Note Padarn 27/11/12:
+    # This function has been changed and now uses an external c function
+    # to set the 'vertex_values' instead of a python for loop. The function
+    # 'get_triangles_and_vertices_per_node' has been removed and replaced by
+    # 'build_inverted_triangle_structure. This now adds extra stored array to
+    # the mesh object - this could be removed after the c function below uses
+    #them.
+    # Note, the naming of this function seems confusing - it seems to actually
+    # update the 'node values' given a list of vertices.
     def _set_vertex_values(self, vertex_list, A):
         """Go through list of unique vertices
@@ -1303,19 +1314,12 @@
         are obtained from a pts file through fitting
         """
-
-        # Go through list of unique vertices
-        for i_index, unique_vert_id in enumerate(vertex_list):
-            triangles = self.domain.get_triangles_and_vertices_per_node(node=unique_vert_id)
-
-            # In case there are unused points
-            if len(triangles) == 0:
-                continue
-
-            # Go through all triangle, vertex pairs
-            # touching vertex unique_vert_id and set corresponding vertex value
-            for triangle_id, vertex_id in triangles:
-                self.vertex_values[triangle_id, vertex_id] = A[i_index]
-
-        # Intialise centroid and edge_values
+        # If required, set up required arrays storing information about the triangle
+        # vertex structure of the mesh.
+        if not (hasattr(self.domain.mesh, 'number_of_triangles_per_node') and \
+                hasattr(self.domain.mesh, 'vertex_value_indices') and \
+                hasattr(self.domain.mesh, 'node_index')):
+            self.build_inverted_triangle_structure()
+
+        set_vertex_values_c(self, num.array(vertex_list), A)
         self.interpolate()
 
@@ -1576,4 +1580,5 @@
          interpolate_from_vertices_to_edges,\
          interpolate_from_edges_to_vertices,\
+         set_vertex_values_c, \
          update
 else:
Index: trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/quantity_ext.c
===================================================================
--- trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/quantity_ext.c	(revision 8689)
+++ trunk/anuga_core/source/anuga/abstract_2d_finite_volumes/quantity_ext.c	(revision 8690)
@@ -864,4 +864,35 @@
 }
 
+// Note Padarn 27/11/12:
+// This function is used to set all the node values of a quantity
+// from a list of vertices and values at those vertices. Called in
+// quantity.py by _set_vertex_values.
+// Naming is a little confusing - but sticking with convention.
+int _set_vertex_values_c(int num_verts,
+                        long * vertices,
+                        long * node_index,
+                        long * number_of_triangles_per_node,
+                        long * vertex_value_indices,
+                        double * vertex_values,
+                        double * A
+                        ){
+  int i,j,num_triangles,vert,triangle;
+
+  for(i=0;i<num_verts;i++){
+  
+    vert=vertices[i];
+    num_triangles = number_of_triangles_per_node[vertices[i]];
+  
+    for(j=0;j<num_triangles;j++){
+  
+      triangle = vertex_value_indices[node_index[vert]+j];   
+      vertex_values[triangle]=A[i];
+    }
+
+  } 
+
+  return 0;
+
+}
 
 //-----------------------------------------------------
@@ -1011,5 +1042,63 @@
 }
 
-
+PyObject *set_vertex_values_c(PyObject *self, PyObject *args) {
+
+  PyObject *quantity,*domain,*mesh;
+  PyArrayObject *vertex_values, *node_index, *A, *vertices;
+  PyArrayObject *number_of_triangles_per_node, *vertex_value_indices;
+
+  int N,err;
+
+
+  // Convert Python arguments to C
+  if (!PyArg_ParseTuple(args, "OOO", &quantity, &vertices, &A)) {
+    PyErr_SetString(PyExc_RuntimeError, 
+        "quantity_ext.c: set_vertex_values_c could not parse input");
+    return NULL;
+  }
+
+  domain = PyObject_GetAttrString(quantity, "domain");
+  if (!domain) {
+    PyErr_SetString(PyExc_RuntimeError, 
+        "extrapolate_gradient could not obtain domain object from quantity"); 
+    return NULL;
+  }
+
+  mesh = PyObject_GetAttrString(domain, "mesh");
+  if (!mesh) {
+    PyErr_SetString(PyExc_RuntimeError, 
+        "extrapolate_gradient could not obtain mesh object from domain"); 
+    return NULL;
+  }
+
+  vertex_values        = get_consecutive_array(quantity, "vertex_values");
+  node_index             = get_consecutive_array(mesh,"node_index");
+  number_of_triangles_per_node = get_consecutive_array(mesh,"number_of_triangles_per_node");
+  vertex_value_indices = get_consecutive_array(mesh,"vertex_value_indices");
+
+  CHECK_C_CONTIG(vertices);
+  CHECK_C_CONTIG(A);
+
+  //N = centroid_values -> dimensions[0];
+
+  int num_verts = vertices->dimensions[0];
+  
+  err = _set_vertex_values_c(num_verts,
+                          (long*) vertices->data,
+                          (long*) node_index->data,
+                          (long*) number_of_triangles_per_node->data,
+                          (long*) vertex_value_indices->data,
+                          (double*) vertex_values->data,
+                          (double*) A->data);
+
+
+  // Release and return
+  Py_DECREF(vertex_values);
+  Py_DECREF(node_index);
+  Py_DECREF(number_of_triangles_per_node);
+  Py_DECREF(vertex_value_indices);
+
+  return Py_BuildValue("");
+}
 
 PyObject *interpolate(PyObject *self, PyObject *args) {
@@ -2278,5 +2367,6 @@
 	{"interpolate", interpolate, METH_VARARGS, "Print out"},
 	{"average_vertex_values", average_vertex_values, METH_VARARGS, "Print out"},		
-	{NULL, NULL, 0, NULL}   // sentinel
+	{"set_vertex_values_c", set_vertex_values_c, METH_VARARGS, "Print out"},	
+{NULL, NULL, 0, NULL}   // sentinel
 };
 
Index: trunk/anuga_core/source/anuga/caching/caching.py
===================================================================
--- trunk/anuga_core/source/anuga/caching/caching.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/caching/caching.py	(revision 8690)
@@ -391,5 +391,4 @@
   ##if options['savestat']:
     addstatsline(CD,funcname,FN,Retrieved,reason,comptime,loadtime,compressed)
-
   return(T)  # Return results in all cases
 
@@ -934,5 +933,44 @@
         reason = 3 # Arguments have changed 
         
-    
+   # PADARN NOTE 17/12/12: Adding a special case to handle the existence of a 
+  # FitInterpolate object. C Structures are serialised so they can be pickled.
+  #---------------------------------------------------------------------------
+  from anuga.fit_interpolate.general_fit_interpolate import FitInterpolate
+  
+  # Setup for quad_tree extension
+  from anuga.utilities import compile
+  if compile.can_use_C_extension('quad_tree_ext.c'):
+      import quad_tree_ext
+  else:
+      msg = "C implementation of quad tree extension not avaliable"
+      raise Exception(msg)
+
+  # Setup for sparse_matrix extension
+  from anuga.utilities import compile
+  if compile.can_use_C_extension('sparse_matrix_ext.c'):
+      import sparse_matrix_ext
+  else:
+      msg = "C implementation of sparse_matrix extension not avaliable"
+      raise Exception(msg)
+
+  from anuga.geometry.aabb import AABB
+
+  if isinstance(T, FitInterpolate):
+
+    if hasattr(T,"D"):
+        T.D=sparse_matrix_ext.deserialise_dok(T.D)
+    if hasattr(T,"AtA"):
+        T.AtA=sparse_matrix_ext.deserialise_dok(T.AtA)
+    if hasattr(T,"root"):
+        if hasattr(T.root,"root"):
+            mesh = T.mesh
+            extents = AABB(*mesh.get_extent(absolute=True))
+            extents.grow(1.001)  # To avoid round off error
+            extents = [extents.xmin, extents.xmax, extents.ymin, extents.ymax]
+            T.root.root=quad_tree_ext.deserialise(T.root.root,\
+                              mesh.triangles, mesh.vertex_coordinates, num.array(extents))
+
+  #---------------------------------------------------------------------------
+
   return((T, FN, Retrieved, reason, comptime, loadtime, compressed))
 
@@ -1078,4 +1116,39 @@
   import time, os, sys
 
+  # PADARN NOTE 17/12/12: Adding a special case to handle the existence of a 
+  # FitInterpolate object. C Structures are serialised so they can be pickled.
+  #---------------------------------------------------------------------------
+  from anuga.fit_interpolate.general_fit_interpolate import FitInterpolate
+  
+  # Setup for quad_tree extension
+  from anuga.utilities import compile
+  if compile.can_use_C_extension('quad_tree_ext.c'):
+      import quad_tree_ext
+  else:
+      msg = "C implementation of quad tree extension not avaliable"
+      raise Exception(msg)
+
+  # Setup for sparse_matrix extension
+  from anuga.utilities import compile
+  if compile.can_use_C_extension('sparse_matrix_ext.c'):
+      import sparse_matrix_ext
+  else:
+      msg = "C implementation of sparse_matrix extension not avaliable"
+      raise Exception(msg)
+
+  from anuga.geometry.aabb import AABB
+
+  if isinstance(T, FitInterpolate):
+    if hasattr(T,"D"):
+        T.D=sparse_matrix_ext.serialise_dok(T.D)
+    if hasattr(T,"AtA"):
+        T.AtA=sparse_matrix_ext.serialise_dok(T.AtA)
+    if hasattr(T,"root"):
+        if hasattr(T.root,"root"):
+            T.root.root=quad_tree_ext.serialise(T.root.root)
+
+
+  #---------------------------------------------------------------------------
+
   (datafile, compressed1) = myopen(CD+FN+'_'+file_types[0],'wb',compression)
   (admfile, compressed2) = myopen(CD+FN+'_'+file_types[2],'wb',compression)
@@ -1114,4 +1187,25 @@
   #else:
   #  pass  # FIXME: Take care of access rights under Windows
+
+  # PADARN NOTE 17/12/12: See above - deserialise in case will be used.
+  #---------------------------------------------------------------------------
+  from anuga.fit_interpolate.general_fit_interpolate import FitInterpolate
+
+  if isinstance(T, FitInterpolate):
+    if hasattr(T,"D"):
+        T.D=sparse_matrix_ext.deserialise_dok(T.D)
+    if hasattr(T,"AtA"):
+        T.AtA=sparse_matrix_ext.deserialise_dok(T.AtA)
+    if hasattr(T,"root"):
+        if hasattr(T.root,"root"):
+            mesh = T.mesh
+            extents = AABB(*mesh.get_extent(absolute=True))
+            extents.grow(1.001)  # To avoid round off error
+            extents = [extents.xmin, extents.xmax, extents.ymin, extents.ymax]
+            T.root.root=quad_tree_ext.deserialise(T.root.root,\
+                              mesh.triangles, mesh.vertex_coordinates, num.array(extents))
+
+
+  #---------------------------------------------------------------------------
 
   return(savetime)
Index: trunk/anuga_core/source/anuga/config.py
===================================================================
--- trunk/anuga_core/source/anuga/config.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/config.py	(revision 8690)
@@ -178,5 +178,5 @@
 
 # Water depth below which it is considered to be 0 in the model
-minimum_allowed_height = 0.001
+minimum_allowed_height = 1.0e-3 
 
 # Water depth below which it is *stored* as 0
Index: trunk/anuga_core/source/anuga/file_conversion/sww2array.py
===================================================================
--- trunk/anuga_core/source/anuga/file_conversion/sww2array.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/file_conversion/sww2array.py	(revision 8690)
@@ -98,5 +98,5 @@
     if verbose:
         log.critical('Reading from %s' % name_in)
-        log.critical('Output directory is %s' % name_out)
+
 
     from Scientific.IO.NetCDF import NetCDFFile
Index: trunk/anuga_core/source/anuga/file_conversion/test_urs2sts.py
===================================================================
--- trunk/anuga_core/source/anuga/file_conversion/test_urs2sts.py	(revision 8689)
+++ trunk/anuga_core/source/anuga/file_conversion/test_urs2sts.py	(revision 8690)
@@ -1958,9 +1958,6 @@
         if not sys.platform == 'win32':
             os.remove(sts_file+'.sts')
-
-        try:
-            os.remove(meshname)
-        except:
-            pass
+        
+        os.remove(meshname)
         
         
